#ifndef __NRF24L01_H__
#define __NRF24L01_H__
#include<reg52.h>
#define uchar unsigned char
#define uint unsigned int

#define TX_ADR_WIDTH    5   	
#define RX_ADR_WIDTH    5   	
#define TX_PLOAD_WIDTH  32  	
#define RX_PLOAD_WIDTH  32
							         
//ͨ32λbit39~8̶뷢͵ַ32λͬ
//LSBbit7~0ģͨͬɣ
///***************************************NRF24L01Ĵָ*******************************************************
#define WRITE_REG       0x20 	// дĴָ
#define RD_RX_PLOAD     0x61   // ȡָ  
#define WR_TX_PLOAD     0xA0   // дָ  
#define FLUSH_TX        0xE1  // շͻFIFOָֱӷ0xff  
#define FLUSH_RX        0xE2   // ճϴջFIFOָ(ֱӷ0xff)  
#define REUSE_TX_PL     0xE3   // ظװָ  
#define NOP             0xFF   // Уַʱã


//Ĵַ  AAAAA //ַʱֱĴַͿԡ     
// 0xff     //ղҪĵַspiдҪд0xffд0xffͬʱģüĴã

// 1AAAAA  //൱ڶ100000ʮƵ0x20Ҫд0x00ĴʱҪд0x00+0x20ڵֵ

//*************************************SPI(nRF24L01)Ĵַ****************************************************  
#define CONFIG          0x00  // շ״̬CRCУģʽԼշ״̬Ӧʽ  
#define EN_AA           0x01  // ԶӦ  
#define EN_RXADDR       0x02  // ŵ  
#define SETUP_AW        0x03  // շַ  
#define SETUP_RETR      0x04  // Զط  
#define RF_CH           0x05  // Ƶ  
#define RF_SETUP        0x06  // ʡĹ  
#define STATUS          0x07  // ״̬Ĵ
  
#define OBSERVE_TX      0x08  // ͼ⹦  
#define CD              0x09  // ַ             
#define RX_ADDR_P0      0x0A  // Ƶ0ݵַ  
#define RX_ADDR_P1      0x0B  // Ƶ1ݵַ  
#define RX_ADDR_P2      0x0C  // Ƶ2ݵַ  
#define RX_ADDR_P3      0x0D  // Ƶ3ݵַ  
#define RX_ADDR_P4      0x0E  // Ƶ4ݵַ  
#define RX_ADDR_P5      0x0F  // Ƶ5ݵַ  
#define TX_ADDR         0x10  // ͵ַĴ  
#define RX_PW_P0        0x11  // Ƶ0ݳ  
#define RX_PW_P1        0x12  // Ƶ0ݳ  
#define RX_PW_P2        0x13  // Ƶ0ݳ  
#define RX_PW_P3        0x14  // Ƶ0ݳ  
#define RX_PW_P4        0x15  // Ƶ0ݳ  
#define RX_PW_P5        0x16  // Ƶ0ݳ  
#define FIFO_STATUS     0x17  // FIFOջջ״̬Ĵ  

//**************************************************************************************
//STATUSĴȡֵ
//bit0:TX FIFO־;bit[3:1],ͨ(:6);bit4,ﵽط
//bit5:ݷж;bit6:ж;
#define MAX_TX  		0x10  //ﵽʹж
#define TX_OK   		0x20  //TXж
#define RX_OK   		0x40  //յж(Ĭͨ0)
//ڽжϺжĸͨյݣɷضӦͨ
#define RX_CH0          0x40  //ͨ0յ
#define RX_CH1          0x42  //ͨ1յ
#define RX_CH2          0x44  //ͨ2յ
#define RX_CH3          0x46 //ͨ3յ
#define RX_CH4          0x48  //ͨ4յ
#define RX_CH5          0x4a  //ͨ5յ

///*****************************Ӻ*********************************************************
uchar SPI_ReadWriteByte(uchar dat);
uchar RF_WR_REG(uchar reg, uchar value);
uchar RF_RD_REG(uchar reg);
uchar RF_RD_BUF(uchar reg, uchar *pBuf, uchar Len);
uchar RF_WR_BUF(uchar reg, uchar *pBuf, uchar Len);
uchar RF_RX_Pack(unsigned char* rx_buf);
uchar RF_TX_Pack(unsigned char* tx_buf);

void NRF24L01_Init(void);
void TX_Mode(void);
void RX_Mode(void);
uchar NRF24L01_Check(void);
///*************************************************************************************
 
 
 #endif
