
#include<reg52.h>
#include"nrf24l01.h"
#define uchar unsigned char
#define uint unsigned int

sbit	CE	    =P2^0;
sbit	CSN		=P2^1;
sbit	SCK	    =P2^2;
sbit 	MOSI	=P2^3;
sbit 	MISO	=P2^4;
sbit	IRQ		=P2^5;

const uchar TX_ADD [5]={0x12,0x75,0x75,0x75,0x75};
const uchar RX_ADD0[5]={0x12,0x75,0x75,0x75,0x75}; //ͨ0뷢ַͬ 

const uchar RX_ADD1[5]={0x34,0x75,0x75,0x75,0x75};
const uchar RX_ADD2[5]={0x56,0x75,0x75,0x75,0x75};
const uchar RX_ADD3[5]={0x78,0x75,0x75,0x75,0x75};
const uchar RX_ADD4[5]={0x9a,0x75,0x75,0x75,0x75};
const uchar RX_ADD5[5]={0xbd,0x75,0x75,0x75,0x75};
//ͨ32λbit39~8̶뷢͵ַ32λͬ
//LSBbit7~0ģͨͬɣ


uchar SPI_ReadWriteByte(uchar byte)	 //SPI дʱģ1
{
	uchar bit_ctr;
   	for(bit_ctr=0;bit_ctr<8;bit_ctr++)    //  8 λ
   	{
   		MOSI = (byte & 0x80);         // MOSI,Ӹλλ.BYTE λΪ1ʱ߼Ϊ1,1.Ϊ0ʱ0
   		byte = (byte << 1);            // 1λ.λλת.
   		SCK = 1;                      // SCK,
   		byte |= MISO;       		  	// MISO ж״̬λBYTE.
   		SCK = 0;            		 	// SCK.һλ.
   	}
    return(byte);           		 	// ״̬λ              
}
/*		
uchar SPI_ReadWriteByte(uchar da) 	  //SPI дʱģ2
 { 
  uchar i,temp=0; 
  SCK=0; 
  for(i=0;i<8;i++) 
  {  
   if(da&0x80) 
   MOSI=1; 
   else 
   MOSI=0;
   SCK=1; 
//   delay_us(2);  //ȶ 
   temp<<=1;  
   if(MISO) 
   temp|=0x01; 
   SCK=0;  
   da<<=1;// 
//   delay_us(2);  //ȶ 
 } 
  return temp; 
 } 		 */

void Delay_n10us(uint n)	   //ʱn10us
{
   for(;n>0;n--)
   {
   	 unsigned char a,b;
     for(b=1;b>0;b--)
         for(a=2;a>0;a--);
   }
}
///****************************************************************************************
///*NRF24L01Ƿ
///***************************************************************************************/
uchar NRF24L01_Check(void)
{
	uchar buf[5]={0XA5,0XA5,0XA5,0XA5,0XA5};
	uchar i;   	 
	RF_WR_BUF(0x20+TX_ADDR,buf,5);//д5ֽڵĵַ.	
	RF_RD_BUF(TX_ADDR,buf,5);              //дĵַ  	
	for(i=0;i<5;i++)if(buf[i]!=0XA5)break;					   
	if(i!=5)return 1;                               //NRF24L01λ	
	return 0;		                                //NRF24L01λ
}	 	 
///****************************************************************************************
///*NRF24L01ʼ
///***************************************************************************************/
void NRF24L01_Init(void)
{
   CE = 0;    // Ͳʹ
   CSN= 1;    // رƬѡ
   SCK=0;     //ʱ
}
///****************************************************************************************************
///*uchar SPI_Read(uchar reg)
///*ܣNRF24L01SPIʱ
///****************************************************************************************************/
uchar RF_RD_REG(uchar reg)
{
	uchar reg_val;
	
	CSN = 0;                
	SPI_ReadWriteByte(reg);            
	reg_val = SPI_ReadWriteByte(0);   
	CSN = 1;                
	
	return(reg_val);       
}
//****************************************************************************************************/
//*ܣNRF24L01дĴ
//****************************************************************************************************/
uchar RF_WR_REG(uchar reg, uchar value)
{
	uchar status;
	
	CSN = 0;                  
	status = SPI_ReadWriteByte(reg);
	SPI_ReadWriteByte(value);           
	CSN = 1; 
	                  	
	return(status);           
}
///****************************************************************************************************/
//*uint SPI_Read_Buf(uchar reg, uchar *pBuf, uchar Len)
//*: ڶݣregΪĴַpBufΪݵַucharsݵĸ
//****************************************************************************************************/
uchar RF_RD_BUF(uchar reg, uchar *pBuf, uchar Len)
{
	uint status,i;
	
	CSN = 0;                    		
	status = SPI_ReadWriteByte(reg);       	
	
    for(i=0;i<Len;i++)
   {
     pBuf[i] = SPI_ReadWriteByte(0);
   }
	
	CSN = 1;                           
	
	return(status);                    
}
//*********************************************************************************************************
//*uint SPI_Write_Buf(uchar reg, uchar *pBuf, uchar Len)
//*: дݣΪĴַpBufΪдݵַucharsдݵĸ
//*********************************************************************************************************/
uchar RF_WR_BUF(uchar reg, uchar *pBuf, uchar Len)
{
	uint status,i;
	
	CSN = 0;                   
	status = SPI_ReadWriteByte(reg);   
	for(i=0; i<Len; i++) 
	{
	   SPI_ReadWriteByte(*pBuf++);
	}
	CSN = 1;           
	return(status);    
}

//****************************************************************************************************/
//*void RX_Mode(void)
//*ܣݽ 
//****************************************************************************************************/
void RX_Mode()
{
	 CE = 0;	

		RF_WR_BUF((RX_ADDR_P0+0x20),RX_ADD0,5);//ýͨ0ַ
		RF_WR_REG(RX_PW_P0+0x20,32);//Чݿ32ֽ


		RF_WR_BUF((RX_ADDR_P1+0x20),RX_ADD1,5);//ýͨ1ַ
		RF_WR_REG(RX_PW_P1+0x20,32);//Чݿ32ֽ
	
		//ͨ2~5ĸ32λַλдֻдһֽ
		RF_WR_BUF((RX_ADDR_P2+0x20),RX_ADD2,1);//ýͨ2ַ
		RF_WR_REG(RX_PW_P2+0x20,32);//Чݿ32ֽ

		RF_WR_BUF((RX_ADDR_P3+0x20),RX_ADD3,1);//ýͨ3ַ
		RF_WR_REG(RX_PW_P3+0x20,32);//Чݿ32ֽ

		RF_WR_BUF((RX_ADDR_P4+0x20),RX_ADD4,1);//ýͨ4ַ
		RF_WR_REG(RX_PW_P4+0x20,32);//Чݿ32ֽ

		RF_WR_BUF((RX_ADDR_P5+0x20),RX_ADD5,1);//ýͨ5ַ
		RF_WR_REG(RX_PW_P5+0x20,32);//Чݿ32ֽ
	
	RF_WR_REG(0x20 + EN_AA, 0x3f);     //  ʹͨԶӦ	
	RF_WR_REG(0x20 + EN_RXADDR,0x3f);  //  ʹͨյַ
	RF_WR_REG(0x20 + RF_CH, 40);        //   ŵΪ2.4GHZշһ 
	RF_WR_REG(0x20 + RF_SETUP, 0x0F);   //÷Ϊ2MHZ书Ϊֵ0dB	
	RF_WR_REG(0x20 + CONFIG, 0x0F);	
	CE = 1; 
	Delay_n10us(20); //200us
}
//****************************************************************************************************/
//*void TX_Mode(void)
//*ܣݷ 
//****************************************************************************************************/
void TX_Mode(void)
{
    CE = 0;

	RF_WR_BUF((TX_ADDR+0x20),RX_ADD1,5);	//͵ַĴд͵ĵַ˴1ͨΪ
	RF_WR_BUF((RX_ADDR_P0+0x20),RX_ADD1,5);
						//Ӧͨ0дַĵַͨ0ĵַ
						//ӦźŵԴַնַͨ0ͨΪԶӦͨ
	
	RF_WR_REG((EN_AA+0x20),0x3f);//ʹͨԶӦ
	RF_WR_REG((EN_RXADDR+0x20),0x3f);//ʹͨյַ
	RF_WR_REG((SETUP_RETR+0x20),0x1a);//Զطʱ500usԶطʮ
	RF_WR_REG((RF_CH+0x20),40);//ùƵΪ2.4Gշһ
	RF_WR_REG((RF_SETUP+0x20),0x0f);
	//ãزأBit5Bit3ͬ2MbƵأ书0db棬濪
	RF_WR_REG((CONFIG+0x20),0x0e);
	//ʹжϣжϣжϣжϣע01رգ
	//Уλʹ
	//ģʽ Bit00ͣ1գ
    CE = 1;
}

uchar RF_RX_Pack(uchar *rxbuf)
{
	uchar status;
	status=RF_RD_REG(STATUS);//ȡ״̬Ĵֵ
	RF_WR_REG((STATUS+0x20),status);//״̬Ĵд״ֵ̬жϱ־
	if(status&RX_OK)//״̬ĴĽжϱ־λ1˵յ
	{
	 RF_RD_BUF(RD_RX_PLOAD,rxbuf,32);//ȡ
	 RF_WR_REG(FLUSH_RX,0xff);//սFIFO
	 return status;
	 }
	return 0xff;//ûյκ
}

uchar RF_TX_Pack(uchar *txbuf)
{
	uchar status;
	CE=0;
	RF_WR_BUF(WR_TX_PLOAD,txbuf,32);	//װݵNRF24L01
	//עRD_RX_PLOADָдĴʲҪ0x20
	CE=1;//ͣ10Us
	while(IRQ!=0);//ȴжźͣ뷢жϣ
	status=RF_RD_REG(STATUS);//ȡ״̬Ĵֵ
	RF_WR_REG((STATUS+0x20),status);//TX_DSMAX_RTжϱ־
	if(status&MAX_TX)//ﵽط
	{
		RF_WR_REG(FLUSH_TX,0xff);//շFIFO
		return status;
	}
	if(status&TX_OK)//ͳɹ
	{
		RF_WR_REG(FLUSH_TX,0xff);//շFIFO
		return status;	
	}

	return 0xff;//ʧ	
}
 
